<script lang="ts" setup>
import ListComment from '~/components/ListComment.vue';
import type { Comment, Picture, User } from '~/entities';

const route = useRoute();
const user = useAuth();


const { data } = await useFetch<Picture>('http://localhost:8080/api/picture/' + route.params.id);

const {data:comments, execute} = await useFetch<Comment[]>('http://localhost:8080/api/picture/'+route.params.id+'/comment', {immediate:false});

if(!data.value) {
  throw createError({
    status: 404,
    message: 'Picture not found'
  });
}

async function addComment(comment:Comment) {
  if(!data.value) return;
  comment.picture = data.value;
  const headers = useRequestHeaders(['cookie']);
  await $fetch('http://localhost:8080/api/comment', {
    method: 'POST',
    body: comment,
    credentials:'include',
    headers
  });
  execute();
}
</script>

<template>
  <div v-if="data">
    <h1>{{ data.title }}</h1>
    <h2>{{ data.author?.email }}</h2>

    <img :src="data.imageLink" :alt="data.title">
    <p>{{ data.description }}</p>
    <p>{{ data.createdAt }}</p>

    <button class="btn btn-primary" @click="execute()" v-if="!comments">Show Comments</button>
    <div v-if="comments">
      <h3>Comments</h3>
      <ListComment :list="comments" />

      <FormComment v-if="user" @submit="addComment($event)" />
    </div>
  </div>
</template>

<style scoped></style>
